#ifndef H_HELP
#define H_HELP

#if defined(ARDUINO) && ARDUINO >= 100
  #include <Arduino.h>
#else
  #include <WProgram.h>
#endif

#include "consts.h"

#ifdef DEBUG
  #define TRACELN(TEXT) Serial.println(TEXT)
  #define TRACE(TEXT) Serial.print(TEXT)
#else
  #define TRACELN(TEXT)
  #define TRACE(TEXT)
#endif

#include "rc.h"
#include "receiver.h"

boolean rcPressed(){
//  int value = getPPMDelay(0);
//  return value > 1500;
//  return getReceiver();
 return false;
}

double getVolt(){
  int v = analogRead(VOLTPIN);
  double v2 = v / 1023.0 * 5.0;
  double v3 = v2 * KVOLTAGE;
  return v3;
}

void setPinModes(){
  //pinMode(VOLTPIN, INPUT);
  pinMode(BPIN, INPUT);
  for (int i=0; i<N; i++){
    pinMode(pins[i], OUTPUT);
  }
}

void doAll(char value){
  for (int i=0; i<N; i++){
    digitalWrite(pins[i], value);
  }  
}

unsigned long buttonPressed(){
  static unsigned long time;
  unsigned long dt = 0;
  if (digitalRead(BPIN) == HIGH || rcPressed()){
    time = millis();
    doAll(HIGH);
    delay(50);
    while(digitalRead(BPIN) == HIGH || rcPressed()){
      delay(10);
      dt = millis() - time;
      if (dt > 1000){
        doAll(LOW);
        delay(200);
        doAll(HIGH);
        delay(200);
        doAll(LOW);
        delay(200);
        doAll(HIGH);
        delay(200);
      }
    }    
    delay(50);
    doAll(LOW);
    dt = millis() - time;
  }  
  return dt;
}


#endif
