#ifndef H_PROGRAM
#define H_PROGRAM

#if defined(ARDUINO) && ARDUINO >= 100
  #include <Arduino.h>
#else
  #include <WProgram.h>
#endif

#include "consts.h"

struct Timing{
  int time;
  char pin;
  char value;
  
  void play(){
    digitalWrite(pins[pin], value);
  } 

};

class Program{  
  public:
  
    Program(){
      addingTime = 0;
      n = 0;
      nowIndex = 0;
    }
    
    void add(unsigned long deltaTime, char pin, char value){
      addingTime += deltaTime;
      Timing t;
      t.time = addingTime;
      t.pin = pin;
      t.value = value;
      a[n] = t;
      n++;    
    }
    
    void start(){
      last = 0;
      doFirst();
    }
    
    void tick(unsigned long dt){
      last += dt;
      while(a[nowIndex].time <= last){
        a[nowIndex].play();
        nowIndex++;
        
        if (nowIndex == n){
          nowIndex == 0;
          doFirst();
          last = 0;
        }
      }
      
    }
    
  protected:
    Timing a[20];
    int n;
    int addingTime;
    int last;
    char nowIndex;
    
    void doFirst(){
      char i = 0;
      while( (a[i].time == 0) && (i < n) ){
        a[i].play();
        i++;
        nowIndex = i;
      }
    }
  
};




#endif
