#include "help.h"
#include "consts.h"
#include "program.h"
#include "programs.h"
#include <EEPROM.h>
#include "rc.h"
#include "receiver.h"

Programs programs;

unsigned long lastTick = 0;
unsigned long now = 0;
unsigned long lastUpVoltTime = 0;
unsigned long lastDownVoltTime = 0;


double v = 0;

int dtime = 0;



#define AV_COUNT 500.0

double receiver_v = 0;

unsigned long r_lastUpTime = 0;
unsigned long r_lastDownTime = 0;
unsigned long r_lastTick = 0;

boolean receiver_up = false;

void initReceiver(){
  pinMode(RCPIN, INPUT);
}

void countReceiver(){
  int v = analogRead(RCPIN);
  if (v > 500){
    receiver_v = receiver_v / AV_COUNT * (AV_COUNT - 1) + 1.0 / AV_COUNT;
  }else{
    receiver_v = receiver_v / AV_COUNT * (AV_COUNT - 1) + 0.0 / AV_COUNT;
  }
  
  if (receiver_v > 1.8/20.0){
    doAll(HIGH);
    delay(500);
    doAll(LOW);
    delay(500);
    receiver_v = 0.0;
    programs.incProgram();    
  }
}

boolean getReceiver(){
  countReceiver();
  //return receiver_up;
  return receiver_v > 1.8/20.0;
}




void setup(){
  
  byte rcpins[] = {RCPIN};
  initEfRc(rcpins, 1);
  
  #ifdef DEBUG
  Serial.begin(9600);
  #endif
  
  setPinModes();

  programs.start();
  
  lastTick = millis();
  
  v = getVolt();
  initReceiver();
}

void loop(){  
  now = millis();
  dtime = now - lastTick;
  lastTick = now;
  
  countReceiver();
  
  v = getVolt();

  if (v > LOWVOLT){
    lastUpVoltTime = now;
    if (programs.low){
      if (STAB_INTERVAL < now - lastDownVoltTime){
        programs.low = false;
      }
    }
  }else{
    lastDownVoltTime = now;
    if (!programs.low){
      if (STAB_INTERVAL < now - lastUpVoltTime){
        programs.low = true;
      }        
    }
  }  

  TRACE(v);
  TRACE(" ");
  TRACE(programs.low);
  TRACE(" rcPressed = ");
  TRACE(rcPressed());
  TRACE("\n");
  
  int pushTime = buttonPressed();
  if (pushTime > 0){
    if(pushTime > 1000){
      doAll(LOW);
      programs.incProgramSet();
    }else{
      doAll(LOW);
      programs.incProgram();
    }
  }

  programs.tick(dtime);  
}
